<template>
  <nav>
    <i :class="$attachReactablePostfix('fas fa-wifi div9')">
      {{ pingErrorCount > 1 ? $t('PING.ERROR') : `${responseTime} ms` }}
    </i>
    <router-link :to="{ name: 'LandingPage' }">
      <div id="logo">
        <p>PRESWOT</p> 
        <span v-if="authType===0" style="color: white;">{{ $t("TOS.STUDENT_DISPLAY") }}</span>      
        <span v-if="authType===1" style="color: white;">{{ $t("TOS.TEACHER_DISPLAY") }}</span>
                     
      </div>
      
    </router-link>
       
    <div id="profile">
      <div id="profile1">
        <el-button
          style="float: right"
          @click="onClick('LOGOUT')"
          size="small"
          type="plain"
          >{{ $t("HEADER.LOGOUT_BUTTON") }}
        </el-button>
        <i v-if ="authType ===0" class="el-icon-user-solid"></i>
        <i v-if ="authType !==0" class="el-icon-s-custom"></i>
        {{ $t("HEADER.WELCOME") }}
        <br />
        {{
          $t("HEADER.USER", {
            name: authName,
          })
        }}
      </div>
      <div id="profile4">
         <el-dropdown @command="onClick">
          <span class="el-dropdown-link" style="color: white"
            >{{ $t("HEADER.PROFILE_BUTTON")
            }}<i class="el-icon-arrow-down el-icon--right"></i
          ></span>
          <el-dropdown-menu slot="dropdown">
            <el-dropdown-item command = "ChangePassword">{{ $t("TOS.CHANGE_PASSWORD")}}</el-dropdown-item>
            <el-dropdown-item command = "ChangeAuthType" v-if="authType ===0 || authType===1">{{ $t("TOS.CHANGE_USER_TYPE")}} 
          <el-popover
            placement="bottom-start"
            width="600"
            trigger="hover"
            title="계정변환"
            >
           <i slot="reference" class="el-icon-question"></i>
            <el-table :data="noticeAuthChange">
            <el-table-column width="150" property="title" :label="$t('ITEM.MODE')"></el-table-column>
            <el-table-column width="450" property="content" :label="$t('ITEM.EXP')"></el-table-column>
            </el-table>
                  
          </el-popover>
          </el-dropdown-item>
          </el-dropdown-menu>
        </el-dropdown>
      </div>
      <div id="profile2"> 
        <el-dropdown @command="onClick">
          <span class="el-dropdown-link" style="color: white"
            >{{ $t("HEADER.LANGUAGE")
            }}<i class="el-icon-arrow-down el-icon--right"></i
          ></span>
          <el-dropdown-menu slot="dropdown">
            <el-dropdown-item command="LOCALE_KO">한국어</el-dropdown-item>
            <el-dropdown-item command="LOCALE_EN">English</el-dropdown-item>
          </el-dropdown-menu>
        </el-dropdown>
      </div>
    </div>
  
    <div class="elmenu" :key="navCount">
      <el-menu
        class="el-menu-vertical-demo"
        style="border-right: 1px solid #4366ac"
        background-color="#4366ac"
        text-color="#fff"
        font-weight="900"
        :unique-opened="true"
        :default-active="$route.path"
        ref="elMenu"
        :router="true"
      >
        <div v-if="authType > 1">
          <el-menu-item :index="findRoutesPathByName('LandingPage')">
            <i class="el-icon-menu"></i>
            <span>{{ $t("HEADER.OVERVIEW") }}</span>
          </el-menu-item>
        </div>
        <div v-if="authType !== 3">
          <el-menu-item
            @click="menuClick('mySpace')"
            :index="
              findRoutesPathByName(
                `NN${authType === 0 ? 'Student' : 'Teacher'}ClassIndex`
              )
            "
          >
            <i class="el-icon-s-platform"></i>
            <span>{{ $t("HEADER.MYSPACE") }}</span>
            <i
              :class="`el-submenu__icon-arrow el-icon-arrow-${
                mySpaceOpen ||
                myClassOpen.some(
                  (classOpen) =>
                    classOpen.state > 0 ||
                    classOpen.childOpen.some((open) => open)
                )
                  ? 'up'
                  : 'down'
              }`"
            ></i>
          </el-menu-item>
          <div
            v-if="
              mySpaceOpen ||
              myClassOpen.some(
                (classOpen) =>
                  classOpen.state > 0 ||
                  classOpen.childOpen.some((open) => open)
              )
            "
          >
            <div
              v-for="(classs, index) in authType === 0
                ? studyingClasses
                : teachingClasses"
              :key="index"
            >
              <el-menu-item
                @click="menuClick('myClass', index)"
                :index="
                  findRoutesPathByName(
                    `NN${authType === 0 ? 'Student' : 'Teacher'}ClassShow`,
                    {
                      classId: classs.classId,
                    }
                  )
                "
                style="padding-left: 40px"
              >
                <span>{{ classs.className }}</span>
                <i
                  :class="`el-submenu__icon-arrow el-icon-arrow-${
                    myClassOpen[index] ? (myClassOpen[index].state === 2 ||
                    myClassOpen[index].childOpen.some((open) => open)
                      ? 'up'
                      : 'down') : 'up'
                  }`"
                ></i>
              </el-menu-item>
              <div
                v-if="
                  myClassOpen[index] ? (myClassOpen[index].state === 2 ||
                  myClassOpen[index].childOpen.some((open) => open)) : false
                "
              >
                <el-menu-item
                  v-for="(menu, idxx) in authType === 0
                    ? classSubMenus.student
                    : classSubMenus.teacher"
                  :key="idxx"
                  :index="
                    findRoutesPathByName(menu.pathName, {
                      classId: classs.classId,
                      pageNum: 0,
                      userId,
                    })
                  "
                  style="padding-left: 60px"
                  >{{ `- ${$t(menu.menuName)}` }}</el-menu-item
                >
              </div>
            </div>
          </div>
        </div>
        <div v-else>
          <el-menu-item :index="findRoutesPathByName('ErrorManage')">
            <i class="el-icon-menu"></i>
            <span>{{ $t('RECORD.ERROR_MANAGE') }}</span>
          </el-menu-item>
        </div>
        <div v-if="authType === 0">
          <el-menu-item :index="findRoutesPathByName('StudentEnrollClass')">
            <i class="el-icon-suitcase-1"></i>
            <span>{{ $t("HEADER.REG_COURSE") }}</span>
          </el-menu-item>
          <el-menu-item :index="findRoutesPathByName('OpenSpace')">
            <i class="el-icon-bank-card"></i>
            <span>{{ $t("HEADER.OPEN_SPACE") }}</span>
          </el-menu-item>
        </div>
        <div v-if="authType === 1">
          <el-menu-item :index="findRoutesPathByName('TeacherClassManage')">
            <i class="el-icon-suitcase-1"></i>
            <span>{{ $t("HEADER.MANAGE_COURSE") }}</span>
          </el-menu-item>
          <el-menu-item :index="findRoutesPathByName('Bank')">
            <i class="el-icon-bank-card"></i>
            <span>{{ $t("HEADER.LCT_BANK") }}</span>
          </el-menu-item>
        </div>
        <div v-if="authType === 4">
          <el-menu-item :index="findRoutesPathByName('TeacherClassManage')">
            <i class="el-icon-suitcase-1"></i>
            <span>{{ $t("HEADER.MANAGE_COURSE") }}</span>
          </el-menu-item>
          <el-menu-item :index="findRoutesPathByName('ReqCreateClass')">
            <i class="el-icon-bank-card"></i>
            <span>{{ $t("HEADER.MANAGE_REQ_CREATE_CLASS") }}</span>
          </el-menu-item>
        </div>
        <!-- <el-menu-item :index="findRoutesPathByName('Download')">
          <i class="el-icon-download"></i>
          <span>{{ $t("HEADER.DOWNLOAD") }}</span>
        </el-menu-item>
        <el-menu-item @click="recordClick" v-if="authType < 2">
          <i class="el-icon-video-camera-solid"></i>
          <span>{{ recordingState ? '영상녹화중지' : '영상녹화시작' }}</span>
        </el-menu-item> -->
      </el-menu>
    </div>

    <!-- 2021-05-17 알림확인, 다운로드, 영상녹화 버튼-->    
    <div align="center" style="margin-bottom: 5px;">      
      <br>
      <br>
      <router-link to="/download">        
        <el-button size="mini" type="plain" style="font-size: 8px" :index="findRoutesPathByName('Download')">        
          <i class="fas fa-download" style="color: #7999cd;"></i>
          <span>{{ $t("HEADER.DOWNLOAD") }}</span>        
        </el-button>
      </router-link>
      <el-button size="mini" type="plain" style="font-size: 8px; margin-left: 10px" @click="recordClick" v-if="authType < 2">        
        <i class="fas fa-video" style="color: #7999cd"></i>
        <span>{{ recordingState ? '녹화중지' : '녹화시작' }}</span>
        <!-- <span>{{ $t("HEADER.OVERVIEW") }}</span>         -->
      </el-button>      
      <el-button size="mini" type="plain" style="font-size: 8px" @click="openEventNotifications()">
        <i class="fas fa-bell" style="color: #7999cd"></i>
        <span>{{ $t("HEADER.NOTIFICATION") }}</span>        
      </el-button>      
    </div>

  </nav>
</template>
<script>
import { mapState, mapActions, mapMutations } from "vuex";
// import { resetState } from '../../stores';
import classService from "../../services/classService";
import utils from "../../utils";
import authService from '../../services/authService';

export default {
  data() {
    return {
      mySpaceOpen: false,
      myClassOpen: [],
      path: "",
      navCount: 0,
      noticeAuthChange: [
        {
          title: this.$t("TOS.CHANGE_TO_TEACHER"),
          content: this.$t("TOS.EXPLAIN_CHANGE_TEACHER"),
        },
        {
          title: this.$t("TOS.CHANGE_TO_STUDENT"),
          content: this.$t("TOS.EXPLAIN_CHANGE_STUDENT"),
        },
        {
          title: this.$t("TOS.EXPLAIN_CHANGE"),
          content: this.$t("TOS.EXPLAIN_CHANGE_DETAIL"),
        },
        
      ],
      classSubMenus: {
        student: [
          { pathName: "NNClassNotice", menuName: "CLASS_MENU.NOTICE" },
          { pathName: "NNClassQuestionAnswer", menuName: "CLASS_MENU.BOARD" },
          // {
          //   pathName: "StudentClassAttendance",
          //   menuName: "CLASS_MENU.ATTEND_MANAGE",
          // },
          {
            pathName: "StudentClassGrade",
            menuName: "STUDENT_MENU.VIEW_RESULTS",
          },
          {
            pathName: "StudentClassJournal",
            menuName: "CLASS_MENU.JOURNALING",
          },
        ],
        teacher: [
          { pathName: "NNClassNotice", menuName: "CLASS_MENU.NOTICE" },
          { pathName: "NNClassQuestionAnswer", menuName: "CLASS_MENU.BOARD" },
          {
            pathName: "TeacherClassAttendance",
            menuName: "CLASS_MENU.ATTEND_MANAGE",
          },
          {
            pathName: "TeacherClassReporting",
            menuName: "CLASS_MENU.SCORE_MANAGE",
          },
          {
            pathName: "NNTeacherClassGrading",
            menuName: "CLASS_MENU.GRADING_MANAGE",
          },
          {
            pathName: "NNTeacherClassJournal",
            menuName: "CLASS_MENU.JOURNALING",
          },
        ],
      },
    };
  },
  props: {
    recording: Boolean,
    responseTime: Number,
    pingErrorCount: Number,
  },
  computed: {
    ...mapState("auth", ["jwt"]),
    ...mapState("NNclass", ["studyingClassList", "teachingClassList"]),

    recordingState() {
      const vm = this;
      return vm.recording;
    },
    authName() {
      const vm = this;
      const jwt = vm.$store.state.auth.jwt;
      return utils.getNameFromJwt(jwt);
    },
    authType() {
      const vm = this;
      const jwt = vm.$store.state.auth.jwt;
      return utils.getAuthTypeFromJwt2(jwt);
    },
    userId() {
      return utils.getUserIdFromJwt();
    },
    studyingClasses() {
      const vm = this;
      return vm.studyingClassList
        ? vm.studyingClassList
            .map((classData) => ({
              className: classData.name, // 과목 이름 김신현 태스트
              date: vm.getFormatDate(new Date(classData.updated_at)),
              dateSort: new Date(classData.updated_at),
              classId: classData.class_id,
            }))
            .sort((a, b) => {
              return b.dateSort - a.dateSort;
            })
        : [];
    },
    teachingClasses() {
      const vm = this;
      return vm.teachingClassList
        ? vm.teachingClassList
            .map((classData) => ({
              className: classData.name, // 과목 이름 김신현 태스트
              date: vm.getFormatDate(new Date(classData.updated_at)),
              dateSort: new Date(classData.updated_at),
              classId: classData.class_id,
            }))
            .sort((a, b) => {
              return b.dateSort - a.dateSort;
            })
        : [];
    },
  },
  watch: {
    $route(to, from) {
      const vm = this;

      vm.openCheck();

      vm.path = vm.$router.currentRoute.path;
    },
  },
  methods: {
    ...mapActions("NNclass", ["getMyClassLists"]),
    ...mapMutations("auth", ["updateJwt", "updateTemporalJwt", "updateLocale"]),
    openEventNotifications(){
      const vm = this;
      vm.$listeners['hello1']();
    },
    recordClick() {
      const vm = this;
      if (vm.recordingState) {
        vm.$listeners['stopRecord']();
      } else {
        vm.$listeners['startRecord']();
      }
    },
    menuClick(type, index) {
      const vm = this;

      if (vm.path === vm.$router.currentRoute.path) {
        switch (type) {
          case "mySpace": {
            vm.mySpaceOpen = !vm.mySpaceOpen;
            break;
          }
          case "myClass": {
            vm.myClassOpen[index].state = 3 - vm.myClassOpen[index].state;
            break;
          }
        }
      }
    },
    pathCheck(path) {
      const vm = this;

      return vm.$router.currentRoute.path === path;
    },
    openCheck() {
      const vm = this;

      vm.mySpaceOpen = vm.pathCheck(
        vm.findRoutesPathByName(
          `NN${vm.authType === 0 ? "Student" : "Teacher"}ClassIndex`
        )
      );
      vm.updateMyClassOpen();
    },
    updateMyClassOpen() {
      const vm = this;
      const myClasses =
        vm.authType === 0 ? vm.studyingClasses : vm.teachingClasses;

      vm.myClassOpen = myClasses
        ? myClasses.map((classs) => ({
            state: vm.pathCheck(
              vm.findRoutesPathByName(
                `NN${vm.authType === 0 ? "Student" : "Teacher"}ClassShow`,
                {
                  classId: classs.classId,
                }
              )
            )
              ? 2
              : 0,
            childOpen: (vm.authType === 0
              ? vm.classSubMenus.student
              : vm.classSubMenus.teacher
            ).map((subMenu) =>
              vm.pathCheck(
                vm.findRoutesPathByName(subMenu.pathName, {
                  classId: classs.classId,
                  userId: vm.userId,
                  pageNum: 0,
                })
              )
            ),
          }))
        : [];
    },
    onClick(command) {
      const vm = this;
      switch (command) {
        case "LOGOUT": {
          vm.updateJwt({
            jwt: "",
          });
          // resetState();
          vm.$router.push({
            name: "Login",
          });
          // TODO: translation
          vm.$notify({
            title: vm.$t("HEADER.LOGOUT_BUTTON"),
            message: vm.$t("NOTIFY.LOGOUT_SUCCESS"),
            type: "success",
          });
          break;
        }
        case "LOCALE_KO": {
          vm._changeLocale("ko"); // eslint-disable-line no-underscore-dangle
          break;
        }
        case "LOCALE_EN": {
          vm._changeLocale("en"); // eslint-disable-line no-underscore-dangle
          break;
        }
        case "ChangePassword": {
           vm.$router.push({
            name: 'ProfileEdit',
          });
          break;
        }
        case "ChangeAuthType": {
          const vm = this;
          if(vm.authType ==0){
          vm.$confirm(         
          vm.$t("TOS.CHAGNE_TEACHER_AUTH_LOGOUT"),        
          vm.$t("TOS.CHANGE_AUTH_TYPE_NOTICE"),
            {           
             cancelButtonText: vm.$t("NO"),
             confirmButtonText: vm.$t("YES"), 
             type: "warning",
            }
          )
          .then(async () => {
            const accessId = utils.getUserIdFromJwt();
            const auth_aaa = await authService.changeAuth({userID: accessId});
            vm.$notify({
            title: vm.$t('TOS.CHANGE_USER_TYPE'),
            message: vm.$t('TOS.COMPLETE_USER_TYPE_CHANGE'),
            type: 'success',
            });

            vm.updateJwt({
              jwt: '',
            });
            vm.updateTemporalJwt({
              jwt: '',
            });
            if (vm.$route.meta.auth) {
              vm.$router.push({ name: 'LandingPage' });
            }
            setTimeout(() => {
              location.reload();
            }, 800);
          })
        };
        if(vm.authType ==1){
          vm.$confirm(         
          vm.$t("TOS.CHANGE_STUDENT_AUTH_LOGOUT"),        
          vm.$t("TOS.CHANGE_AUTH_TYPE_NOTICE"),
            {           
             cancelButtonText: vm.$t("NO"),
             confirmButtonText: vm.$t("YES"), 
             type: "warning",
            }
          )
          .then(async () => {
            const accessId = utils.getUserIdFromJwt();
            const auth_aaa = await authService.changeAuth({userID: accessId});
            vm.$notify({
            title: vm.$t('TOS.CHANGE_USER_TYPE'),
            message: vm.$t('TOS.COMPLETE_USER_TYPE_CHANGE'),
            type: 'success',
            });

            vm.updateJwt({
              jwt: '',
            });
            vm.updateTemporalJwt({
              jwt: '',
            });
            if (vm.$route.meta.auth) {
              vm.$router.push({ name: 'LandingPage' });
            }
            setTimeout(() => {
              location.reload();
            }, 800);
          })
        };
        }
      }
    },
    findRoutesPathByName(name, params = {}) {
      const vm = this;

      let { path } = vm.$router.options.routes.filter(
        (route) => route.name === name
      )[0];

      for (const [key, val] of Object.entries(params)) {
        path = path.replace(`:${key}`, val);
      }

      return `/${path
        .split("/")
        .filter((a) => a)
        .join("/")}`;
    },
    // localeType(type) {
    //   const vm = this;
    //   const typeArray = [{
    //     en: 'student',
    //     ko: '학생'
    //   }, {
    //     en: 'teacher',
    //     ko: '강사'
    //   }, {
    //     en: '',
    //     ko: '',
    //   }, {
    //     en: 'admin',
    //     ko: '관리자',
    //   }, {
    //     en: 'admin',
    //     ko: '관리자',
    //   }];

    //   if (vm.$i18n.locale === "ko") {
    //     return typeArray[type].ko;
    //   } else {
    //     return typeArray[type].en;
    //   }
    // },
    _changeLocale(locale) {
      const vm = this;
      vm.$i18n.locale = locale;
      vm.updateLocale({
        locale,
      });
    },
    getFormatDate(date) {
      var year = date.getFullYear(); //yyyy
      var month = 1 + date.getMonth(); //M
      month = month >= 10 ? month : "0" + month; //month 두자리로 저장
      var day = date.getDate(); //d
      day = day >= 10 ? day : "0" + day; //day 두자리로 저장
      return year + "년 " + month + "월 " + day + "일"; //'-' 추가하여 yyyy-mm-dd 형태 생성 가능
    },
  },
  async mounted() {
    const vm = this;

    vm.path = vm.$router.currentRoute.path;
    await vm.getMyClassLists();

    vm.openCheck();
  },
};
</script>

<style scoped>
/* --------------------------style---------------------------- */
a {
  text-decoration: none;
}

.div9 {
  position: relative;
  top: 10px;
  left: 20px;
  color: white;
  font-size: 0.8em;
}

nav {
  height: 100%;
  /* Full-height: remove this if you want "auto" height */
  width: 300px !important;
  /* Set the width of the sidebar */
  position: fixed;
  /* Fixed Sidebar (stay in place on scroll) */
  z-index: 1;
  /* Stay on top */
  top: 0;
  /* Stay at the top */
  left: 0;
  background-color: #4366ac;
  /* background-color: #7ea8f5; */
  overflow-x: hidden;
  /* Disable horizontal scroll */
  color: #fff;
}

#noLink {
  color: white;
  text-decoration: none;
}

#logo {
  padding: 10px 0 20px 0;
  text-align: center;
}

#logo > p {
  font-size: 25px;
  font-weight: bold;
  font-family: "Roboto", sans-serif;
  color: #fff;
}

#profile {
  padding: 20px 20px 20px 10px;
}

#profile1 img {
  float: left;
  margin: 5px;
}

#profile1 i {
  float: left;
  font-size: 60px;
}

#profile1 > p {
  margin: 10px 0 10px 0;
}
#profile1 {
  margin-bottom: 5px;
}

#profile2 {
  text-align: right;
}

#profile2 p:nth-child(1) {
  float: left;
  margin: 0;
}

#profile3 {
  float: right;
  margin: 5px;
}
#profile4 {
  float: left;
  margin: 1px;
}

#navList {
  list-style: none;
  margin: 0;
}

#navList i {
  vertical-align: middle;
  font-size: 30px;
}

#elmenu {
  font-weight: 400;
}

.elmenu i {
  color: #fff;
}

/* --------------------------style---------------------------- */
</style>
